Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2528)
@@ -7,4 +7,5 @@
    !!              -   ! 2008-01  (R. Benshila)  change averaging method
    !!             3.2  ! 2009-07  (R. Benshila, G. Madec) Complete revisit associated to vvl reactivation
+   !!             3.3  ! 2010-09  (D. Storkey, E. O'Dea) update for BDY for Shelf configurations
   !!---------------------------------------------------------------------
 #if defined key_dynspg_ts   ||   defined key_esopa
@@ -50,5 +51,7 @@
    REAL(wp), DIMENSION(jpi,jpj) ::  ftsw, ftse   ! (only used with een vorticity scheme)
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   un_b, vn_b   ! averaged velocity
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   un_b, vn_b   ! now    averaged velocity
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   ub_b, vb_b   ! before averaged velocity
+
 
    !! * Substitutions
@@ -56,7 +59,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!-------------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software is governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!-------------------------------------------------------------------------
 
@@ -81,8 +84,8 @@
       !!          momentum and continuity integration. Barotropic former 
       !!          variables are time averaging over the full barotropic cycle
-      !!          (= 2 * baroclinic time step) and saved in zuX_b 
-      !!          and zvX_b (X specifying after, now or before).
+      !!          (= 2 * baroclinic time step) and saved in uX_b 
+      !!          and vX_b (X specifying after, now or before).
       !!      -3- The new general trend becomes :
-      !!          ua = ua - sum_k(ua)/H + ( ua_e - sum_k(ub) )
+      !!          ua = ua - sum_k(ua)/H + ( un_b - ub_b )
       !!
       !! ** Action : - Update (ua,va) with the surf. pressure gradient trend
@@ -93,6 +96,5 @@
       !!
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
-      INTEGER  ::   icycle                           ! temporary integers
-      INTEGER  ::   ikbu, ikbv, ikbum1, ikbvm1       !   -          -
+      INTEGER  ::   icycle           ! temporary scalar
 
       REAL(wp) ::   zraur, zcoef, z2dt_e, z2dt_b     ! temporary scalars
@@ -108,6 +110,6 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zsshun_e, zsshvn_e   ! 2D workspace
       !!
-      REAL(wp), DIMENSION(jpi,jpj) ::   zcu, zwx, zua, zun, zub   ! 2D workspace
-      REAL(wp), DIMENSION(jpi,jpj) ::   zcv, zwy, zva, zvn, zvb   !  -      -
+      REAL(wp), DIMENSION(jpi,jpj) ::   zcu, zwx, zua, zun   ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   zcv, zwy, zva, zvn   !  -      -
       REAL(wp), DIMENSION(jpi,jpj) ::   zun_e, zub_e, zu_sum      ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj) ::   zvn_e, zvb_e, zv_sum      !  -      -
@@ -160,6 +162,6 @@
       !                                   !* e3*d/dt(Ua), e3*Ub, e3*Vn (Vertically integrated)
       !                                   ! --------------------------
-      zua(:,:) = 0.e0   ;   zun(:,:) = 0.e0   ;   zub(:,:) = 0.e0
-      zva(:,:) = 0.e0   ;   zvn(:,:) = 0.e0   ;   zvb(:,:) = 0.e0
+      zua(:,:) = 0.e0   ;   zun(:,:) = 0.e0 
+      zva(:,:) = 0.e0   ;   zvn(:,:) = 0.e0 
       !
       DO jk = 1, jpkm1
@@ -177,7 +179,4 @@
                zun(ji,jj) = zun(ji,jj) + fse3u  (ji,jj,jk) * un(ji,jj,jk)
                zvn(ji,jj) = zvn(ji,jj) + fse3v  (ji,jj,jk) * vn(ji,jj,jk)               
-               !                                                                              ! before velocity
-               zub(ji,jj) = zub(ji,jj) + fse3u_b(ji,jj,jk) * ub(ji,jj,jk) 
-               zvb(ji,jj) = zvb(ji,jj) + fse3v_b(ji,jj,jk) * vb(ji,jj,jk)
             END DO
          END DO
@@ -265,15 +264,9 @@
          DO ji = 2, jpim1
 # endif
-            ikbu = MIN( mbathy(ji+1,jj), mbathy(ji,jj) )
-            ikbv = MIN( mbathy(ji,jj+1), mbathy(ji,jj) )
-            ikbum1 = MAX( ikbu-1, 1 )
-            ikbvm1 = MAX( ikbv-1, 1 )
-
-            !
             ! Apply stability criteria for bottom friction
-            !RBbug for vvl and external mode we may need to
-            ! use varying fse3
-            zbfru  (ji,jj) = MAX( bfrua(ji,jj), fse3u(ji,jj,ikbum1)*zcoef )
-            zbfrv  (ji,jj) = MAX( bfrva(ji,jj), fse3v(ji,jj,ikbvm1)*zcoef )
+            !RBbug for vvl and external mode we may need to use varying fse3
+            !!gm  Rq: the bottom e3 present the smallest variation, the use of e3u_0 is not a big approx.
+            zbfru(ji,jj) = MAX(  bfrua(ji,jj) , fse3u(ji,jj,mbku(ji,jj)) * zcoef  )
+            zbfrv(ji,jj) = MAX(  bfrva(ji,jj) , fse3v(ji,jj,mbkv(ji,jj)) * zcoef  )
          END DO
       END DO
@@ -282,7 +275,7 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * zub(ji,jj)   &
+               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * ub_b(ji,jj)   &
                   &       / ( hu_0(ji,jj) + sshu_b(ji,jj) + 1.e0 - umask(ji,jj,1) )
-               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * zvb(ji,jj)   &
+               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * vb_b(ji,jj)   &
                   &       / ( hv_0(ji,jj) + sshv_b(ji,jj) + 1.e0 - vmask(ji,jj,1) )
             END DO
@@ -291,6 +284,6 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * zub(ji,jj) * hur(ji,jj)
-               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * zvb(ji,jj) * hvr(ji,jj)
+               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * ub_b(ji,jj) * hur(ji,jj)
+               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * vb_b(ji,jj) * hvr(ji,jj)
             END DO
          END DO
@@ -302,11 +295,4 @@
       zva(:,:) = zva(:,:) * hvr(:,:)
       !
-      IF( lk_vvl ) THEN
-         zub(:,:) = zub(:,:) * umask(:,:,1) / ( hu_0(:,:) + sshu_b(:,:) + 1.e0 - umask(:,:,1) )
-         zvb(:,:) = zvb(:,:) * vmask(:,:,1) / ( hv_0(:,:) + sshv_b(:,:) + 1.e0 - vmask(:,:,1) )
-      ELSE
-         zub(:,:) = zub(:,:) * hur(:,:)
-         zvb(:,:) = zvb(:,:) * hvr(:,:)
-      ENDIF
 
       ! -----------------------------------------------------------------------
@@ -354,6 +340,6 @@
          !                                                !* Update the forcing (OBC, BDY and tides)
          !                                                !  ------------------
-         IF( lk_obc                     )   CALL obc_dta_bt( kt, jn   )
-         IF( lk_bdy  .OR.  ln_bdy_tides )   CALL bdy_dta_bt( kt, jn+1 )
+         IF( lk_obc )   CALL obc_dta_bt ( kt, jn   )
+         IF( lk_bdy )   CALL bdy_dta_fla( kt, jn+1, icycle )
 
          !                                                !* after ssh_e
@@ -382,5 +368,5 @@
          DO jj = 2, jpjm1                                      ! leap-frog on ssh_e
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ssha_e(ji,jj) = ( zsshb_e(ji,jj) - z2dt_e * ( zraur * emp(ji,jj) + zhdiv(ji,jj) ) ) * tmask(ji,jj,1)
+               ssha_e(ji,jj) = ( zsshb_e(ji,jj) - z2dt_e * ( zraur * ( emp(ji,jj)-rnf(ji,jj) ) + zhdiv(ji,jj) ) ) * tmask(ji,jj,1) 
             END DO
          END DO
@@ -478,6 +464,6 @@
          !                                                      !         - Correct the velocity
 
-         IF( lk_obc                   )   CALL obc_fla_ts
-         IF( lk_bdy .OR. ln_bdy_tides )   CALL bdy_dyn_fla( sshn_e ) 
+         IF( lk_obc               )   CALL obc_fla_ts
+         IF( lk_bdy .OR. ln_tides )   CALL bdy_dyn_fla( sshn_e ) 
          !
          CALL lbc_lnk( ua_e  , 'U', -1. )                      ! local domain boundaries 
@@ -545,13 +531,17 @@
       !                                   !* Time average ==> after barotropic u, v, ssh
       zcoef =  1.e0 / ( 2 * nn_baro  + 1 ) 
-      un_b  (:,:) = zcoef * zu_sum  (:,:) 
-      vn_b  (:,:) = zcoef * zv_sum  (:,:) 
-      sshn_b(:,:) = zcoef * zssh_sum(:,:) 
+      zu_sum(:,:) = zcoef * zu_sum  (:,:) 
+      zv_sum(:,:) = zcoef * zv_sum  (:,:) 
       ! 
       !                                   !* update the general momentum trend
       DO jk=1,jpkm1
-         ua(:,:,jk) = ua(:,:,jk) + ( un_b(:,:) - zub(:,:) ) / z2dt_b
-         va(:,:,jk) = va(:,:,jk) + ( vn_b(:,:) - zvb(:,:) ) / z2dt_b
+         ua(:,:,jk) = ua(:,:,jk) + ( zu_sum(:,:) - ub_b(:,:) ) / z2dt_b
+         va(:,:,jk) = va(:,:,jk) + ( zv_sum(:,:) - vb_b(:,:) ) / z2dt_b
       END DO
+      ub_b (:,:) = un_b(:,:)
+      vb_b (:,:) = vn_b(:,:)
+      un_b  (:,:) =  zu_sum(:,:) 
+      vn_b  (:,:) =  zv_sum(:,:) 
+      sshn_b(:,:) = zcoef * zssh_sum(:,:) 
       !
       !                                   !* write time-spliting arrays in the restart
@@ -598,4 +588,37 @@
             vn_b (:,:) = vn_b(:,:) * hvr(:,:)
          ENDIF
+
+         ! Vertically integrated velocity (before)
+         IF (neuler/=0) THEN
+            ub_b (:,:) = 0.e0
+            vb_b (:,:) = 0.e0
+
+            ! vertical sum
+            IF( lk_vopt_loop ) THEN          ! vector opt., forced unroll
+               DO jk = 1, jpkm1
+                  DO ji = 1, jpij
+                     ub_b(ji,1) = ub_b(ji,1) + fse3u_b(ji,1,jk) * ub(ji,1,jk)
+                     vb_b(ji,1) = vb_b(ji,1) + fse3v_b(ji,1,jk) * vb(ji,1,jk)
+                  END DO
+               END DO
+            ELSE                             ! No  vector opt.
+               DO jk = 1, jpkm1
+                  ub_b(:,:) = ub_b(:,:) + fse3u_b(:,:,jk) * ub(:,:,jk)
+                  vb_b(:,:) = vb_b(:,:) + fse3v_b(:,:,jk) * vb(:,:,jk)
+               END DO
+            ENDIF
+
+            IF( lk_vvl ) THEN
+               ub_b (:,:) = ub_b(:,:) * umask(:,:,1) / ( hu_0(:,:) + sshu_b(:,:) + 1.e0 - umask(:,:,1) )
+               vb_b (:,:) = vb_b(:,:) * vmask(:,:,1) / ( hv_0(:,:) + sshv_b(:,:) + 1.e0 - vmask(:,:,1) )
+            ELSE
+               ub_b(:,:) = ub_b(:,:) * hur(:,:)
+               vb_b(:,:) = vb_b(:,:) * hvr(:,:)
+            ENDIF
+         ELSE                                 ! neuler==0
+            ub_b (:,:) = un_b (:,:)
+            vb_b (:,:) = vn_b (:,:)
+         ENDIF
+
          IF( iom_varid( numror, 'sshn_b', ldstop = .FALSE. ) > 0 ) THEN
             CALL iom_get( numror, jpdom_autoglo, 'sshn_b' , sshn_b (:,:) )   ! filtered extrenal ssh
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 2528)
@@ -14,13 +14,14 @@
    !!            2.0  !  2006-11  (G. Madec)  flux form advection: add metric term
    !!            3.2  !  2009-04  (R. Benshila)  vvl: correction of een scheme
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   dyn_vor     : Update the momentum trend with the vorticity trend
-   !!       vor_ens : enstrophy conserving scheme       (ln_dynvor_ens=T)
-   !!       vor_ene : energy conserving scheme          (ln_dynvor_ene=T)
-   !!       vor_mix : mixed enstrophy/energy conserving (ln_dynvor_mix=T)
-   !!       vor_een : energy and enstrophy conserving   (ln_dynvor_een=T)
-   !!       vor_ctl : set and control of the different vorticity option
+   !!   dyn_vor      : Update the momentum trend with the vorticity trend
+   !!       vor_ens  : enstrophy conserving scheme       (ln_dynvor_ens=T)
+   !!       vor_ene  : energy conserving scheme          (ln_dynvor_ene=T)
+   !!       vor_mix  : mixed enstrophy/energy conserving (ln_dynvor_mix=T)
+   !!       vor_een  : energy and enstrophy conserving   (ln_dynvor_een=T)
+   !!   dyn_vor_init : set and control of the different vorticity option
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers
@@ -36,5 +37,6 @@
    PRIVATE
 
-   PUBLIC   dyn_vor   ! routine called by step.F90
+   PUBLIC   dyn_vor        ! routine called by step.F90
+   PUBLIC   dyn_vor_init   ! routine called by opa.F90
 
    !                                             !!* Namelist namdyn_vor: vorticity term
@@ -53,7 +55,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3,2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -74,6 +76,4 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL vor_ctl          ! initialisation & control of options
 
       !                                          ! vorticity term 
@@ -637,7 +637,7 @@
 
 
-   SUBROUTINE vor_ctl
+   SUBROUTINE dyn_vor_init
       !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE vor_ctl  ***
+      !!                  ***  ROUTINE dyn_vor_init  ***
       !!
       !! ** Purpose :   Control the consistency between cpp options for
@@ -653,6 +653,6 @@
       IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn:vor_ctl : vorticity term : read namelist and control the consistency'
-         WRITE(numout,*) '~~~~~~~~~~~'
+         WRITE(numout,*) 'dyn_vor_init : vorticity term : read namelist and control the consistency'
+         WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '        Namelist namdyn_vor : oice of the vorticity term scheme'
          WRITE(numout,*) '           energy    conserving scheme                ln_dynvor_ene = ', ln_dynvor_ene
@@ -700,5 +700,5 @@
       ENDIF
       !
-   END SUBROUTINE vor_ctl
+   END SUBROUTINE dyn_vor_init
 
    !!==============================================================================
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 2528)
@@ -31,7 +31,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 2528)
@@ -4,10 +4,11 @@
    !! Ocean dynamics :  vertical component of the momentum mixing trend
    !!==============================================================================
-   !! History :  9.0  !  05-11  (G. Madec)  Original code
+   !! History :  1.0  !  2005-11  (G. Madec)  Original code
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   dyn_zdf      : Update the momentum trend with the vertical diffusion
-   !!       zdf_ctl  : initializations of the vertical diffusion scheme
+   !!   dyn_zdf_init : initializations of the vertical diffusion scheme
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -27,11 +28,9 @@
    PRIVATE
 
-   PUBLIC   dyn_zdf    !  routine called by step.F90
+   PUBLIC   dyn_zdf       !  routine called by step.F90
+   PUBLIC   dyn_zdf_init  !  routine called by opa.F90
 
-   INTEGER  ::   nzdf = 0              ! type vertical diffusion algorithm used 
-      !                                ! defined from ln_zdf...  namlist logicals)
-
-   REAL(wp) ::   r2dt                  ! time-step, = 2 rdttra
-      !                                ! except at nit000 (=rdttra) if neuler=0
+   INTEGER  ::   nzdf = 0   ! type vertical diffusion algorithm used, defined from ln_zdf... namlist logicals
+   REAL(wp) ::   r2dt       ! time-step, = 2 rdttra except at nit000 (=rdttra) if neuler=0
 
    !! * Substitutions
@@ -40,7 +39,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -58,9 +57,7 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 )   CALL zdf_ctl          ! initialisation & control of options
-
       !                                          ! set time step
-      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
-      ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt      ! = 2 rdttra (leapfrog)
+      IF( neuler == 0 .AND. kt == nit000     ) THEN   ;   r2dt =      rdt   ! = rdtra (restart with Euler time stepping)
+      ELSEIF(               kt <= nit000 + 1 ) THEN   ;   r2dt = 2. * rdt   ! = 2 rdttra (leapfrog)
       ENDIF
 
@@ -72,12 +69,12 @@
       SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
       !
-      CASE ( 0 )   ;   CALL dyn_zdf_exp    ( kt, r2dt )      ! explicit scheme
-      CASE ( 1 )   ;   CALL dyn_zdf_imp    ( kt, r2dt )      ! implicit scheme
+      CASE ( 0 )   ;   CALL dyn_zdf_exp( kt, r2dt )      ! explicit scheme
+      CASE ( 1 )   ;   CALL dyn_zdf_imp( kt, r2dt )      ! implicit scheme
       !
       CASE ( -1 )                                      ! esopa: test all possibility with control print
-                       CALL dyn_zdf_exp    ( kt, r2dt )
+                       CALL dyn_zdf_exp( kt, r2dt )
                        CALL prt_ctl( tab3d_1=ua, clinfo1=' zdf0 - Ua: ', mask1=umask,               &
             &                        tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
-                       CALL dyn_zdf_imp    ( kt, r2dt )
+                       CALL dyn_zdf_imp( kt, r2dt )
                        CALL prt_ctl( tab3d_1=ua, clinfo1=' zdf1 - Ua: ', mask1=umask,               &
             &                        tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
@@ -96,7 +93,7 @@
 
 
-   SUBROUTINE zdf_ctl
+   SUBROUTINE dyn_zdf_init
       !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE zdf_ctl  ***
+      !!                 ***  ROUTINE dyn_zdf_init  ***
       !!
       !! ** Purpose :   initializations of the vertical diffusion scheme
@@ -105,24 +102,24 @@
       !!                explicit (time-splitting) scheme if ln_zdfexp=T
       !!----------------------------------------------------------------------
-      USE zdftke_old
       USE zdftke
+      USE zdfgls
       USE zdfkpp
       !!----------------------------------------------------------------------
-
+      !
       ! Choice from ln_zdfexp read in namelist in zdfini
       IF( ln_zdfexp ) THEN   ;   nzdf = 0           ! use explicit scheme
       ELSE                   ;   nzdf = 1           ! use implicit scheme
       ENDIF
-
+      !
       ! Force implicit schemes
-      IF( lk_zdftke_old .OR. lk_zdftke .OR. lk_zdfkpp )   nzdf = 1   ! TKE or KPP physics
-      IF( ln_dynldf_iso                               )   nzdf = 1   ! iso-neutral lateral physics
-      IF( ln_dynldf_hor .AND. ln_sco                  )   nzdf = 1   ! horizontal lateral physics in s-coordinate
-
+      IF( lk_zdftke .OR. lk_zdfgls .OR. lk_zdfkpp )   nzdf = 1   ! TKE, GLS or KPP physics
+      IF( ln_dynldf_iso                           )   nzdf = 1   ! iso-neutral lateral physics
+      IF( ln_dynldf_hor .AND. ln_sco              )   nzdf = 1   ! horizontal lateral physics in s-coordinate
+      !
       IF( lk_esopa )    nzdf = -1                   ! Esopa key: All schemes used
-
+      !
       IF(lwp) THEN                                  ! Print the choice
          WRITE(numout,*)
-         WRITE(numout,*) 'dyn:zdf_ctl : vertical dynamics physics scheme'
+         WRITE(numout,*) 'dyn_zdf_init : vertical dynamics physics scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
          IF( nzdf == -1 )   WRITE(numout,*) '              ESOPA test All scheme used'
@@ -131,5 +128,5 @@
       ENDIF
       !
-   END SUBROUTINE zdf_ctl
+   END SUBROUTINE dyn_zdf_init
 
    !!==============================================================================
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 2528)
@@ -4,7 +4,8 @@
    !! Ocean dynamics:  vertical component(s) of the momentum mixing trend
    !!==============================================================================
-   !! History :      !  90-10  (B. Blanke)  Original code
-   !!                !  97-05  (G. Madec)  vertical component of isopycnal
-   !!           8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !! History :  OPA  !  1990-10  (B. Blanke)  Original code
+   !!            8.0  !  1997-05  (G. Madec)  vertical component of isopycnal
+   !!   NEMO     1.0  !  1002-08  (G. Madec)  F90: Free form and module
+   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
    !!----------------------------------------------------------------------
 
@@ -13,5 +14,4 @@
    !!                  sion using an explicit time-stepping scheme.
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -24,6 +24,5 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC dyn_zdf_exp    ! called by step.F90
+   PUBLIC   dyn_zdf_exp   ! called by step.F90
 
    !! * Substitutions
@@ -31,7 +30,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -47,5 +46,5 @@
       !!      technique. The vertical diffusion of momentum is given by:
       !!         diffu = dz( avmu dz(u) ) = 1/e3u dk+1( avmu/e3uw dk(ub) )
-      !!      Surface boundary conditions: wind stress input
+      !!      Surface boundary conditions: wind stress input (averaged over kt-1/2 & kt+1/2)
       !!      Bottom boundary conditions : bottom stress (cf zdfbfr.F90)
       !!      Add this trend to the general trend ua :
@@ -54,37 +53,29 @@
       !! ** Action : - Update (ua,va) with the vertical diffusive trend
       !!---------------------------------------------------------------------
-      !! * Arguments
-      INTEGER , INTENT( in ) ::   kt                           ! ocean time-step index
-      REAL(wp), INTENT( in ) ::   p2dt                         ! time-step 
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk, jl                              ! dummy loop indices
-      REAL(wp) ::   zrau0r, zlavmr, zua, zva                   ! temporary scalars
-      REAL(wp), DIMENSION(jpi,jpk) ::   zwx, zwy, zwz, zww     ! temporary workspace arrays
+      INTEGER , INTENT(in) ::   kt     ! ocean time-step index
+      REAL(wp), INTENT(in) ::   p2dt   ! time-step 
+      !!
+      INTEGER ::   ji, jj, jk, jl                            ! dummy loop indices
+      REAL(wp) ::   zrau0r, zlavmr, zua, zva                 ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpk) ::   zwx, zwy, zwz, zww   ! 2D workspace
       !!----------------------------------------------------------------------
 
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dyn_zdf_exp : vertical momentum diffusion explicit operator'
+         IF(lwp) WRITE(numout,*) 'dyn_zdf_exp : vertical momentum diffusion - explicit operator'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~ '
       ENDIF
 
-      ! Local constant initialization
-      ! -----------------------------
-      zrau0r = 1. / rau0                                   ! inverse of the reference density
-      zlavmr = 1. / float( nn_zdfexp )                      ! inverse of the number of sub time step
+      zrau0r = 1. / rau0                              ! Local constant initialization
+      zlavmr = 1. / REAL( nn_zdfexp )
 
-      !                                                ! ===============
-      DO jj = 2, jpjm1                                 !  Vertical slab
-         !                                             ! ===============
-
-         ! Surface boundary condition
-         DO ji = 2, jpim1
-            zwy(ji,1) = utau(ji,jj) * zrau0r
-            zww(ji,1) = vtau(ji,jj) * zrau0r
+      !                                               ! ===============
+      DO jj = 2, jpjm1                                !  Vertical slab
+         !                                            ! ===============
+         DO ji = 2, jpim1         ! Surface boundary condition
+            zwy(ji,1) = ( utau_b(ji,jj) + utau(ji,jj) ) * zrau0r
+            zww(ji,1) = ( vtau_b(ji,jj) + vtau(ji,jj) ) * zrau0r
          END DO  
-
-         ! Initialization of x, z and contingently trends array
-         DO jk = 1, jpk
+         DO jk = 1, jpk         ! Initialization of x, z and contingently trends array
             DO ji = 2, jpim1
                zwx(ji,jk) = ub(ji,jj,jk)
@@ -92,10 +83,8 @@
             END DO  
          END DO  
-
-         ! Time splitting loop
-         DO jl = 1, nn_zdfexp
-
-            ! First vertical derivative
-            DO jk = 2, jpk
+         !
+         DO jl = 1, nn_zdfexp     ! Time splitting loop
+            !
+            DO jk = 2, jpk            ! First vertical derivative
                DO ji = 2, jpim1
                   zwy(ji,jk) = avmu(ji,jj,jk) * ( zwx(ji,jk-1) - zwx(ji,jk) ) / fse3uw(ji,jj,jk) 
@@ -103,24 +92,20 @@
                END DO  
             END DO  
-
-            ! Second vertical derivative and trend estimation at kt+l*rdt/nn_zdfexp
-            DO jk = 1, jpkm1
+            DO jk = 1, jpkm1          ! Second vertical derivative and trend estimation at kt+l*rdt/nn_zdfexp
                DO ji = 2, jpim1
-                  zua = zlavmr*( zwy(ji,jk) - zwy(ji,jk+1) ) / fse3u(ji,jj,jk)
-                  zva = zlavmr*( zww(ji,jk) - zww(ji,jk+1) ) / fse3v(ji,jj,jk)
+                  zua = zlavmr * ( zwy(ji,jk) - zwy(ji,jk+1) ) / fse3u(ji,jj,jk)
+                  zva = zlavmr * ( zww(ji,jk) - zww(ji,jk+1) ) / fse3v(ji,jj,jk)
                   ua(ji,jj,jk) = ua(ji,jj,jk) + zua
                   va(ji,jj,jk) = va(ji,jj,jk) + zva
-
-                  zwx(ji,jk) = zwx(ji,jk) + p2dt*zua*umask(ji,jj,jk)
-                  zwz(ji,jk) = zwz(ji,jk) + p2dt*zva*vmask(ji,jj,jk)
+                  !
+                  zwx(ji,jk) = zwx(ji,jk) + p2dt * zua * umask(ji,jj,jk)
+                  zwz(ji,jk) = zwz(ji,jk) + p2dt * zva * vmask(ji,jj,jk)
                END DO  
             END DO  
-
+            !
          END DO  
-
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-
+         !                                            ! ===============
+      END DO                                          !   End of slab
+      !                                               ! ===============
    END SUBROUTINE dyn_zdf_exp
 
